CREATE TABLE `user` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `username` varchar(45) NOT NULL,
  `email` varchar(60) NOT NULL,
  `pass` char(64) DEFAULT NULL,
  `type` enum('public','author','admin') NOT NULL,
  `date_entered` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `authorname_UNIQUE` (`authorname`),
  UNIQUE KEY `email_UNIQUE` (`email`)
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8;

INSERT INTO `author` VALUES (NULL,'Test','text@example.com','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-14 05:00:00'),(2,'Someones','me@example.org','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-01-21 16:32:51'),(3,'Some Author','auth@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','author','2015-03-03 20:59:24'),(4,'Another Author','blah@example.org','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','author','2015-01-27 20:59:24'),(5,'Administrator','admin@example.com','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','admin','2015-02-17 20:59:24'),(6,'Another Admin','admin2@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','admin','2015-02-10 20:59:24'),(7,'Jane','jane@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-02-17 20:59:24'),(8,'John','john@example.org','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-01-27 20:59:24'),(9,'Curly','curly@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-03 20:59:24'),(10,'Moe','moe@example.org','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','author','2015-02-17 20:59:24'),(11,'Larry','larry@example.com','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-03 20:59:24'),(12,'Vlad','vlad@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-02-27 22:16:12'),(13,'testing','testing@example.edu','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-01 00:25:59'),(14,'Latest Test','latest@example.com','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-01 00:32:36'),(15,'Joe Public','jp@example.net','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-01 00:34:40'),(16,'Jane Public','jp@example.com','21f9b9e3c98236d3efb6c8b47a4137a1c7ad59cc84af20e2e8ba41c946f34ab6','public','2015-03-01 03:36:11');

CREATE TABLE `page` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_id` int(10) UNSIGNED NOT NULL,
  `live` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `title` varchar(100) NOT NULL,
  `content` longtext,
  `date_updated` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `date_published` DATE NULL,
  PRIMARY KEY (`id`),
  KEY `fk_page_author_idx` (`author_id`),
  KEY `date_published` (`date_published`),
  CONSTRAINT `fk_page_author` FOREIGN KEY (`author_id`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8;

INSERT INTO `page` VALUES (1,3,1,'Aliquam malesuada, ligula sit amet.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-17'),(2,4,1,'Ten years ago a...','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-18 16:10:18','2015-02-22'),(3,10,0,'Phasellus dapibus dolor et mauris.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18',NULL),(4,4,1,'Thunder, thunder, thundercats, Ho! ','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-19 16:10:18','2015-02-01'),(5,4,1,'Michael Knight, a young loner','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-03-15'),(6,10,1,'Test Title','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-01-03 22:08:35','2015-01-03'),(7,5,1,'Proin eleifend tempus libero ut.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-22'),(8,3,0,'I never spend much time in school...','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18',NULL),(9,6,1,'Nullam vulputate condimentum aliquet. Duis.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-18 16:10:18','2015-02-18'),(10,5,1,'Vivamus et ante ligula, in.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-17'),(11,10,1,'There\'s a voice that keeps on calling me.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-01'),(12,6,1,'Ulysses, Ulysses','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-18 16:10:18','2015-03-15'),(13,10,1,'Muskehounds are always ready.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-01'),(14,4,0,'Barnaby The Bear\'s my name','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18',NULL),(15,4,1,'Hong Kong Phooey, number one super guy.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-19 16:10:18','2015-02-22'),(16,5,1,'Etiam mattis venenatis sodales. In.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-01'),(17,3,1,'80 days around the world,','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-17'),(18,6,1,'Top Cat! The most effectual Top Cat! ','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-03-15'),(19,5,0,'Mauris pulvinar interdum diam, vel.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-18 16:10:18',NULL),(20,10,1,'Round, round, all around the world.','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-17'),(21,6,1,'The Cities of Gold','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam porta lectus sed ipsum tincidunt lacinia. Integer lacinia semper varius. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nulla lobortis nulla et leo egestas at luctus tellus tempor. Nulla faucibus pulvinar metus, quis hendrerit odio porta non. Donec eu metus tincidunt tellus convallis tincidunt a ac quam. Quisque a mollis lectus. Fusce nec pretium libero. Ut rhoncus augue eu elit rutrum at porta lacus aliquet. Pellentesque molestie viverra purus et lacinia. Nulla facilisi. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\n\n<p>Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus. Praesent tincidunt felis id urna lobortis nec luctus ligula semper. Nulla nulla nisl, rhoncus eu vulputate vel, porttitor ut est. Aenean purus nulla, tincidunt non interdum non, suscipit quis lorem. Aenean non ligula neque, sit amet condimentum ipsum. Morbi est nisi, pretium non vestibulum non, adipiscing a tellus.</p>\n\n<p>Mauris eu quam sit amet est consectetur elementum non quis libero. Donec vitae leo at justo pellentesque ullamcorper. Nunc eget eros rhoncus urna lobortis convallis sit amet a urna. Vestibulum nisi turpis, dignissim in adipiscing vitae, sodales quis lorem. Sed neque enim, dapibus eu pretium id, aliquam nec dolor. Quisque viverra risus nec sem pretium sed interdum enim volutpat. Ut dapibus imperdiet nibh, eu molestie felis faucibus ac. Etiam eu malesuada nunc.</p>\n\n<p>Maecenas commodo tortor et turpis tempor tempus. Morbi a arcu elit, in sagittis orci. Donec metus purus, molestie eget fermentum vel, vulputate id odio. Vivamus interdum imperdiet lectus sit amet varius. Sed non accumsan dui. Fusce cursus laoreet mattis. Proin eget velit tortor, a ultrices neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Sed eros tortor, ultricies non mattis a, ultrices et sem. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed sodales malesuada dictum. Nulla facilisi. Donec consequat, odio quis sollicitudin dapibus, risus mi viverra nisl, facilisis facilisis dolor dolor ut est. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; In tincidunt consequat ultricies. Ut vehicula elit non elit scelerisque tristique.</p>\n\n<p>Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.</p>','2015-02-17 16:10:18','2015-02-01'),(23,10,0,'This is my Files Test',NULL,'2015-03-01 09:35:27','0000-00-00');

CREATE TABLE `comment` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_id` int(10) UNSIGNED NOT NULL,
  `page_id` int(10) UNSIGNED NOT NULL,
  `comment` MEDIUMTEXT NOT NULL,
  `date_entered` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `fk_comment_author_idx` (`author_id`),
  KEY `fk_comment_page_idx` (`page_id`),
  KEY `date_entered` (`date_entered`),
  CONSTRAINT `fk_comment_page` FOREIGN KEY (`page_id`) REFERENCES `page` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `fk_comment_author` FOREIGN KEY (`author_id`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARACTER SET=utf8;

INSERT INTO `comment` VALUES (1,9,3,'Duis neque libero, iaculis rhoncus imperdiet a, bibendum in sem. Donec ligula est, sagittis eu iaculis ut, aliquam in lorem. Vivamus gravida diam sit amet leo vestibulum id pulvinar felis ultrices. Curabitur mattis facilisis lorem non viverra. Pellentesque vel augue nisl, nec semper augue. Aenean bibendum pellentesque sodales. Pellentesque sit amet ornare sapien. Nam vestibulum malesuada felis, eu hendrerit arcu congue et. Praesent non orci congue enim bibendum cursus. Sed sit amet tellus nec enim aliquet pellentesque. Aenean ut metus orci, euismod laoreet libero. Etiam non fringilla erat. Nunc leo nulla, fermentum non semper vel, varius sed massa. Aliquam erat volutpat. In hac habitasse platea dictumst. Mauris sit amet fringilla sapien.','2015-01-17 21:10:49'),(2,2,6,'This is my comment.','2015-01-21 16:48:28'),(3,1,6,'This is the page owner\'s reply.','2015-01-21 16:33:46'),(4,1,2,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-17 22:13:31'),(5,2,1,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-18 13:28:31'),(6,3,4,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-18 14:28:31'),(7,4,5,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-18 22:13:31'),(8,5,9,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-18 23:13:31'),(9,6,10,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-18 23:13:31'),(10,7,11,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-19 00:28:31'),(11,8,20,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-19 01:28:31'),(12,9,18,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-19 00:28:31'),(13,10,13,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-19 01:13:31'),(14,11,10,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-20 02:13:31'),(15,2,2,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-20 01:13:31'),(16,3,1,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-20 00:28:31'),(17,4,4,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-20 02:13:31'),(18,5,4,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 01:13:31'),(19,6,3,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 00:28:31'),(20,7,7,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 01:28:31'),(21,8,8,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 02:13:31'),(22,9,8,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 00:28:31'),(23,10,9,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 07:13:31'),(24,1,12,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 05:28:31'),(25,2,12,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 06:13:31'),(26,1,13,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 06:28:31'),(27,4,4,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 08:13:31'),(28,5,15,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 08:13:31'),(29,6,1,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 09:13:31'),(30,7,3,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 00:13:31'),(31,8,10,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-21 22:28:31'),(32,9,18,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-22 00:13:31'),(33,10,21,'Sed bibendum ligula ac urna egestas euismod. Nunc eu molestie purus.','2015-02-21 22:53:31');

CREATE TABLE `file` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_id` int(10) UNSIGNED NOT NULL,
  `name` varchar(80) NOT NULL,
  `type` varchar(45) NOT NULL,
  `size` int(10) UNSIGNED NOT NULL,
  `description` MEDIUMTEXT,
  `date_entered` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `date_updated` DATETIME DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_file_author1_idx` (`author_id`),
  KEY `name` (`name`),
  KEY `date_entered` (`date_entered`),
  CONSTRAINT `fk_file_author` FOREIGN KEY (`author_id`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARACTER SET=utf8;

INSERT INTO `file` VALUES (1,4,'Some File','application/pdf',131072,NULL,'2015-03-01 13:51:37',NULL),(2,6,'Another File','application/pdf',2678046,NULL,'2015-03-01 13:57:22',NULL);

CREATE TABLE `page_has_file` (
  `page_id` int(10) UNSIGNED NOT NULL,
  `file_id` int(10) UNSIGNED NOT NULL,
  PRIMARY KEY (`page_id`,`file_id`),
  KEY `fk_page_has_file_file_idx` (`file_id`),
  KEY `fk_page_has_file_page_idx` (`page_id`),
  CONSTRAINT `fk_page_has_file_file` FOREIGN KEY (`file_id`) REFERENCES `file` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `fk_page_has_file_page` FOREIGN KEY (`page_id`) REFERENCES `page` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8;

INSERT INTO `page_has_file` VALUES (3,1),(23,1),(8,2),(23,2);

